
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2015 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title STREXH

@desc Store Register Exclusive Halfword derives an address from a base register value, and stores a halfword from a register to memory if the executing processor has exclusive access to the memory addressed. For more information about support for shared memory see Synchronization and semaphores on page A3-114. For information about memory accesses see Memory accesses on page A8-294.

@encoding (T1) {

	@word 1 1 1 0 1 0 0 0 1 1 0 0 Rn(4) Rt(4) 1 1 1 1 0 1 0 1 Rd(4)

	@syntax <reg_D> <reg_T> <mem_access>

	@conv {

		reg_D = Register(Rd)
		reg_T = Register(Rt)
		reg_N = Register(Rn)
		mem_access = MakeMemoryAccess(reg_N, NULL, NULL, true, false, false)

	}

}

@encoding (A1) {

	@word cond(4) 0 0 0 1 1 1 1 0 Rn(4) Rd(4) 1 1 1 1 1 0 0 1 Rt(4)

	@syntax <reg_D> <reg_T> <mem_access>

	@conv {

		reg_D = Register(Rd)
		reg_T = Register(Rt)
		reg_N = Register(Rn)
		mem_access = MakeMemoryAccess(reg_N, NULL, NULL, true, false, false)

	}

	@rules {

		chk_call StoreCondition(cond)

	}

}

